<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>gluon: controller_pid/pid_controller.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">gluon
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_80cb61180a2aa844c9344ada03916d41.html">controller_pid</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">pid_controller.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="pid__controller_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#ifndef PID_CONTROLLER_H</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#define PID_CONTROLLER_H</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">//#define PID_CONTROLLER_HEADER_ONLY</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#ifdef PID_CONTROLLER_HEADER_ONLY</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#define PID_CONTROLLER_SPEC static inline</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00017"></a><span class="lineno"><a class="line" href="pid__controller_8h.html#afaf1b99e536ac31c4217a4e5e4dc1bef">   17</a></span>&#160;<span class="preprocessor">#define PID_CONTROLLER_SPEC</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div><div class="line"><a name="l00020"></a><span class="lineno"><a class="line" href="structpid__t.html">   20</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;{</div><div class="line"><a name="l00022"></a><span class="lineno"><a class="line" href="structpid__t.html#ac9bdf7fe0be3e307ec0218f9d806f81d">   22</a></span>&#160;    <span class="keywordtype">float</span> <a class="code" href="structpid__t.html#ac9bdf7fe0be3e307ec0218f9d806f81d">set_point</a>;</div><div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="structpid__t.html#a1f7add0f84d583bc2eceb290d6c4cc06">   23</a></span>&#160;    <span class="keywordtype">float</span> <a class="code" href="structpid__t.html#a1f7add0f84d583bc2eceb290d6c4cc06">kp</a>;</div><div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="structpid__t.html#a050993b7ca6c97e62c1020017f716b91">   24</a></span>&#160;    <span class="keywordtype">float</span> <a class="code" href="structpid__t.html#a050993b7ca6c97e62c1020017f716b91">ki</a>;</div><div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="structpid__t.html#ae7a5c6018507bb1361fcca170e069b9c">   25</a></span>&#160;    <span class="keywordtype">float</span> <a class="code" href="structpid__t.html#ae7a5c6018507bb1361fcca170e069b9c">kd</a>;</div><div class="line"><a name="l00026"></a><span class="lineno"><a class="line" href="structpid__t.html#ab1edebf7e0ad0658e34319952ca4227b">   26</a></span>&#160;    <span class="keywordtype">float</span> <a class="code" href="structpid__t.html#ab1edebf7e0ad0658e34319952ca4227b">min_output_limit</a>;</div><div class="line"><a name="l00027"></a><span class="lineno"><a class="line" href="structpid__t.html#a4ffe8ca155ad7dac8b88208f24b122c1">   27</a></span>&#160;    <span class="keywordtype">float</span> <a class="code" href="structpid__t.html#a4ffe8ca155ad7dac8b88208f24b122c1">max_output_limit</a>;</div><div class="line"><a name="l00028"></a><span class="lineno"><a class="line" href="structpid__t.html#ad448f00939b7adde7f5076732f2ff177">   28</a></span>&#160;    <span class="keywordtype">float</span> <a class="code" href="structpid__t.html#ad448f00939b7adde7f5076732f2ff177">acceptable_error</a>;</div><div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="structpid__t.html#a1174af01b8a329a6d465ea6e0951b3e5">   29</a></span>&#160;    <span class="keywordtype">float</span> <a class="code" href="structpid__t.html#a1174af01b8a329a6d465ea6e0951b3e5">integral</a>;</div><div class="line"><a name="l00030"></a><span class="lineno"><a class="line" href="structpid__t.html#a53bf2ded26ca455e1227890c20123cd9">   30</a></span>&#160;    <span class="keywordtype">float</span> <a class="code" href="structpid__t.html#a53bf2ded26ca455e1227890c20123cd9">last_error</a>;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;} <a class="code" href="structpid__t.html">pid_t</a>;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<a class="code" href="pid__controller_8h.html#afaf1b99e536ac31c4217a4e5e4dc1bef">PID_CONTROLLER_SPEC</a> <span class="keywordtype">void</span> <a class="code" href="pid__controller_8h.html#a037cec7ec9c7aadfcb9274df135f75d0">pid_init</a>(<a class="code" href="structpid__t.html">pid_t</a>* pid, <span class="keywordtype">float</span> kp, <span class="keywordtype">float</span> ki, <span class="keywordtype">float</span> kd,</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;                                  <span class="keywordtype">float</span> min_output_limit,</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;                                  <span class="keywordtype">float</span> max_output_limit,</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;                                  <span class="keywordtype">float</span> acceptable_error);</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<a class="code" href="pid__controller_8h.html#afaf1b99e536ac31c4217a4e5e4dc1bef">PID_CONTROLLER_SPEC</a> <span class="keywordtype">void</span> <a class="code" href="pid__controller_8h.html#aabd48cceaa1e175ce62c4297dd97c39e">pid_set_point</a>(<a class="code" href="structpid__t.html">pid_t</a>* pid, <span class="keywordtype">float</span> set_point);</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<a class="code" href="pid__controller_8h.html#afaf1b99e536ac31c4217a4e5e4dc1bef">PID_CONTROLLER_SPEC</a> <span class="keywordtype">float</span> <a class="code" href="pid__controller_8h.html#abff8c612af4d5c17b2f7141e7b557db2">pid_process</a>(<a class="code" href="structpid__t.html">pid_t</a>* pid, <span class="keywordtype">float</span> process_value,</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;                                      <span class="keywordtype">float</span> dt);</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="preprocessor">#ifdef PID_CONTROLLER_HEADER_ONLY</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="pid__controller_8c.html">pid_controller.c</a>&quot;</span></div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="structpid__t_html_ad448f00939b7adde7f5076732f2ff177"><div class="ttname"><a href="structpid__t.html#ad448f00939b7adde7f5076732f2ff177">pid_t::acceptable_error</a></div><div class="ttdeci">float acceptable_error</div><div class="ttdef"><b>Definition:</b> pid_controller.h:28</div></div>
<div class="ttc" id="structpid__t_html_a1174af01b8a329a6d465ea6e0951b3e5"><div class="ttname"><a href="structpid__t.html#a1174af01b8a329a6d465ea6e0951b3e5">pid_t::integral</a></div><div class="ttdeci">float integral</div><div class="ttdef"><b>Definition:</b> pid_controller.h:29</div></div>
<div class="ttc" id="structpid__t_html_ae7a5c6018507bb1361fcca170e069b9c"><div class="ttname"><a href="structpid__t.html#ae7a5c6018507bb1361fcca170e069b9c">pid_t::kd</a></div><div class="ttdeci">float kd</div><div class="ttdef"><b>Definition:</b> pid_controller.h:25</div></div>
<div class="ttc" id="pid__controller_8h_html_abff8c612af4d5c17b2f7141e7b557db2"><div class="ttname"><a href="pid__controller_8h.html#abff8c612af4d5c17b2f7141e7b557db2">pid_process</a></div><div class="ttdeci">PID_CONTROLLER_SPEC float pid_process(pid_t *pid, float process_value, float dt)</div><div class="ttdef"><b>Definition:</b> pid_controller.c:33</div></div>
<div class="ttc" id="structpid__t_html_a050993b7ca6c97e62c1020017f716b91"><div class="ttname"><a href="structpid__t.html#a050993b7ca6c97e62c1020017f716b91">pid_t::ki</a></div><div class="ttdeci">float ki</div><div class="ttdef"><b>Definition:</b> pid_controller.h:24</div></div>
<div class="ttc" id="pid__controller_8h_html_afaf1b99e536ac31c4217a4e5e4dc1bef"><div class="ttname"><a href="pid__controller_8h.html#afaf1b99e536ac31c4217a4e5e4dc1bef">PID_CONTROLLER_SPEC</a></div><div class="ttdeci">#define PID_CONTROLLER_SPEC</div><div class="ttdef"><b>Definition:</b> pid_controller.h:17</div></div>
<div class="ttc" id="pid__controller_8h_html_aabd48cceaa1e175ce62c4297dd97c39e"><div class="ttname"><a href="pid__controller_8h.html#aabd48cceaa1e175ce62c4297dd97c39e">pid_set_point</a></div><div class="ttdeci">PID_CONTROLLER_SPEC void pid_set_point(pid_t *pid, float set_point)</div><div class="ttdef"><b>Definition:</b> pid_controller.c:28</div></div>
<div class="ttc" id="structpid__t_html_ab1edebf7e0ad0658e34319952ca4227b"><div class="ttname"><a href="structpid__t.html#ab1edebf7e0ad0658e34319952ca4227b">pid_t::min_output_limit</a></div><div class="ttdeci">float min_output_limit</div><div class="ttdef"><b>Definition:</b> pid_controller.h:26</div></div>
<div class="ttc" id="pid__controller_8c_html"><div class="ttname"><a href="pid__controller_8c.html">pid_controller.c</a></div></div>
<div class="ttc" id="structpid__t_html_ac9bdf7fe0be3e307ec0218f9d806f81d"><div class="ttname"><a href="structpid__t.html#ac9bdf7fe0be3e307ec0218f9d806f81d">pid_t::set_point</a></div><div class="ttdeci">float set_point</div><div class="ttdef"><b>Definition:</b> pid_controller.h:22</div></div>
<div class="ttc" id="structpid__t_html_a1f7add0f84d583bc2eceb290d6c4cc06"><div class="ttname"><a href="structpid__t.html#a1f7add0f84d583bc2eceb290d6c4cc06">pid_t::kp</a></div><div class="ttdeci">float kp</div><div class="ttdef"><b>Definition:</b> pid_controller.h:23</div></div>
<div class="ttc" id="structpid__t_html_a4ffe8ca155ad7dac8b88208f24b122c1"><div class="ttname"><a href="structpid__t.html#a4ffe8ca155ad7dac8b88208f24b122c1">pid_t::max_output_limit</a></div><div class="ttdeci">float max_output_limit</div><div class="ttdef"><b>Definition:</b> pid_controller.h:27</div></div>
<div class="ttc" id="structpid__t_html_a53bf2ded26ca455e1227890c20123cd9"><div class="ttname"><a href="structpid__t.html#a53bf2ded26ca455e1227890c20123cd9">pid_t::last_error</a></div><div class="ttdeci">float last_error</div><div class="ttdef"><b>Definition:</b> pid_controller.h:30</div></div>
<div class="ttc" id="pid__controller_8h_html_a037cec7ec9c7aadfcb9274df135f75d0"><div class="ttname"><a href="pid__controller_8h.html#a037cec7ec9c7aadfcb9274df135f75d0">pid_init</a></div><div class="ttdeci">PID_CONTROLLER_SPEC void pid_init(pid_t *pid, float kp, float ki, float kd, float min_output_limit, float max_output_limit, float acceptable_error)</div><div class="ttdef"><b>Definition:</b> pid_controller.c:9</div></div>
<div class="ttc" id="structpid__t_html"><div class="ttname"><a href="structpid__t.html">pid_t</a></div><div class="ttdef"><b>Definition:</b> pid_controller.h:20</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
